/**
 **	File ......... Sequence.cpp
 **	Published ....  2004-05-17
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>
#include <string>
#include <vector>
#include <map>

#include "Token.h"
#include "Scope.h"
#include "Sequence.h"
#include "dp.h"
#include "BaseParser.h" // tokens



Sequence::Sequence()
:m_file("")
,m_line(0)
,m_pos(0)
,m_bExtern(false)
,m_parent(NULL)
{
}


Sequence::Sequence(token_v &tokens)
:m_file("")
,m_line(0)
,m_pos(0)
,m_bExtern(false)
,m_tokens(tokens)
,m_parent(NULL)
{
}


Sequence::~Sequence()
{
	while (m_tokens.size())
	{
		token_v::iterator it = m_tokens.begin();
		Token *t = *it;
		delete t;
		m_tokens.erase(it);
	}
}


void Sequence::Display()
{
	return;
	printf("%s",GetExpr().c_str());
}


void Sequence::Tab()
{
	Scope *p = GetParent();
	while (p && p -> GetParent() )
	{
		printf("\t");
		p = p -> GetParent();
	}
}


std::string Sequence::GetExpr()
{
	std::string tmp;
	bool first = true;
	for (token_v::iterator it = m_tokens.begin(); it != m_tokens.end(); it++)
	{
		Token *t = *it;
		if (t -> GetCode() != COMMENT || first)
		{
			std::string str = t -> GetVal();
//			if (tmp.size() && (isalpha(str[0]) || str[0] == '<' || str[0] == '_' || str[0] == 34 || str[0] == '~') )
//				tmp += " ";
			tmp += str;
		}
		first = false;
	}
	if (config["-xml"] == "true")
		xmlsafestr(tmp);
	return tmp;
}


void Sequence::xmlsafestr(std::string &s) 
{
	std::string str;
	for (size_t i = 0; i < s.size(); i++)
	{
		switch (s[i])
		{
		case '&':
			str += "&amp;";
			break;
		case '<':
			str += "&lt;";
			break;
		case '>':
			str += "&gt;";
			break;
		case '"':
			str += "&quot;";
			break;
		case '\'':
			str += "&apos;";
			break;
		default:
			str += s[i];
		}
	}
	s = str;
}


Token *Sequence::GetFirstToken()
{
	if (!m_tokens.size())
		return NULL;
	token_v::iterator it = m_tokens.begin();
	Token *t = *it;
	return t;
}


