/**
 **	File ......... dp.cpp
 **	Published ....  2004-05-17
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <string>
#include <sys/types.h>
#include <dirent.h>
#include <vector>
#include <sys/stat.h>
#include <unistd.h>
#include <map>
#include "Parse.h"
#include "SimpleParser.h"
#include "BlackAdder.h"
#include "dp.h"

#define DEB(x)


/* This is a comment */

namespace ugly { 
	int beep; 
}

static	BlackAdder add;
	config_m config;
	config_m box;
	std::string includes = "";
	std::string defines = "";

void read_makefile()
{
	FILE *fil;
	if ((fil = fopen("Makefile","rt")) != NULL)
	{
		char slask[1000];
		fgets(slask,1000,fil);
		while (!feof(fil))
		{
			slask[strlen(slask) - 1] = 0;
			if (*slask != '#')
			{
				Parse pa(slask);
				strcpy(slask,pa.getword().c_str());
				while (*slask)
				{
					if (!strncmp(slask,"-I",2))
					{
						if (includes.size())
							includes += " ";
						includes += slask;
					}
					if (!strncmp(slask,"-D",2))
					{
						if (defines.size())
							defines += " ";
						defines += slask;
					}
					//
					strcpy(slask,pa.getword().c_str());
				}
			}
			//
			fgets(slask,1000,fil);
		}
		fclose(fil);
	}
}




void parse_file(const std::string &path,const std::string &filename)
{
	std::string cmd;
	std::string out;
	out = path + "/" + filename + ".preprocessed";
	out = "/tmp/" + filename + ".preprocessed";
	cmd = "/usr/bin/cpp" 
		" -I.."
		" -I."
		" -I/usr/devel/include"
		" " + includes + " " + defines + " " + path + "/" + filename + " > " + out;
fprintf(stderr, "%s\n", cmd.c_str());
	if (system( cmd.c_str() ) == -1)
	{
DEB(		fprintf(stderr,"Command failed: '%s'...\n",cmd.c_str());)
	}
	else
	{
		FILE *fil = fopen(out.c_str(),"rt");
		if (fil)
		{
			SimpleParser p(path,&add);
			int line = 0;
			std::string name;
			name = path + "/";
			name += filename;
			add.clear_using();
			p.Parser(fil,line,name);
			fclose(fil);
			unlink(out.c_str());
		}
	}
}


void loop(const std::string &path)
{
	DIR *d;
	struct dirent *p;
	struct stat st;
	char filename[4000];
	if ((d = opendir(path.c_str())) != NULL)
	{
		p = readdir(d);
		while (p)
		{
			sprintf(filename,"%s/%s",path.c_str(),p -> d_name);
			stat(filename, &st);
//			printf(" type: %08x  name: %s\n",st.st_mode,filename); //p -> d_name);
			if (S_ISDIR(st.st_mode))
			{
				if (p -> d_name[0] != '.')
				{
					std::string subdir = path;
					subdir += "/";
					subdir += p -> d_name;
					loop( subdir );
				}
			}
			else
			{
				if (
//				    !strcasecmp(p -> d_name + strlen(p -> d_name) - 2,".h") ||
				    !strcasecmp(p -> d_name + strlen(p -> d_name) - 4,".cpp") ||
//				    !strcasecmp(p -> d_name + strlen(p -> d_name) - 4,".hpp") ||
				    !strcasecmp(p -> d_name + strlen(p -> d_name) - 3,".cc") ||
				    !strcasecmp(p -> d_name + strlen(p -> d_name) - 4,".c") 
				    )
				{
					parse_file( path, p -> d_name );
				}
			}
			//
			p = readdir(d);
		}
		closedir(d);
	}
}


int main(int argc,char *argv[])
{
	char *args[] = {"-dot","-lr","-cluster",""};
	read_makefile();
	for (int i = 1; i < argc; i++)
	{
		bool ok = false;
		bool more = false;
		int x = 0;
		if (!strncmp(argv[i], "-D", 2))
		{
			if (defines.size())
				defines += " ";
			defines += argv[i];
		}
		else
		if (!strcmp(argv[i],"-box")) // box a namespace
		{
			box[argv[i + 1]] = "true";
			i++;
		}
		else
		{
			while (*args[x])
			{
				if (!strcmp(argv[i],args[x]))
				{
					ok = true;
					// check for more
					break;
				}
				else
				{
					x++;
				}
			}
			if (ok)
			{
				if (more)
				{
					config[argv[i]] = argv[i + 1];
					i++;
				}
				else
				{
					config[argv[i]] = "true";
				}
			}
			else
			{
				printf("Unknown option: '%s'\n",argv[i]);
				printf("Usage: %s",*argv);
				for (int x = 0; *args[x]; x++)
					printf(" [%s]",args[x]);
				printf("\n");
				return -1;
			}
		}
	}
	loop(".");
	if (config["-dot"] == "true")
	{
		printf("digraph test {\n");
		printf("\tURL=\"index.html\"\n");
		if (config["-lr"] == "true")
			printf("	rankdir=LR;\n");
		printf("	node [shape=box style=filled fillcolor=\"#ffffff\" fontsize=9]\n");
		add.MakeDot();
		printf("}\n");
	}
}


